<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\Util;
use HCM\Util\TkEntity;

class FpaParamfolhamEntity extends TkEntity
{

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;

    private $_paramFolha;
    private $_nrParamFolhaAnterior;

    public function __construct($entityManager, $hcmParameters) {
        parent::__construct(null, $entityManager);
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $this->hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $this->hcmParameters->getDtCompetencia();
        $this->_nrParamFolhaAnterior = -1;
    }
    
    public function getTipoArredondamento(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getIdtparredondame();
        }
    }

    public function getDigitoArredondamento(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getNrdigarredondam();
        }
    }

    public function getLimiteArredondamento(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getNrlimarredondam();
        }
    }

    public function getGrupoIncidencia(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getNrgrpincide();
        }
    }

    public function getControleAdmissao(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getNrctrladmissao();
        }
    }

    public function getAcumulaIRRecolhimentoMinimo(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getIdirrfrecolhmin();
        }
    }

    public function getPercentualAdiantamento(){
        
        if (is_object($this->_paramFolha)){
            return $this->_paramFolha->historico->getVrpercentadiant();
        }
    }

    public function getNumeroMinimoAdiantamento(){
        if (is_object($this->_paramFolha)){
            return $this->_paramFolha->historico->getNrmindiasadiant();
        }
    }

    public function getIdRecebeAdiantPriMes(){
        if (is_object($this->_paramFolha)){
            return $this->_paramFolha->historico->getIdrecadianprimes();
        }
    }

    public function getControleFerias(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getNrctrlferias();
        }
    }

    public function getControleAfastamento(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getNrctrlafast();
        }
    }

    public function getIdDesconsideraCompetencia(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getIddesccompetenc();
        }
    }

    public function getIdConsideraMedia1p13(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getIdmedia1p13();
        }
    }

    public function getVrEncargo1Ferias(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getVrenc1ferias();
        }
    }

    public function getVrEncargo1Aviso(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getVrenc1aviso();
        }
    }

    public function getVrEncargo1DecTerceiro(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getVrenc1dec();
        }
    }

    public function getVrEncargo2Ferias(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getVrenc2ferias();
        }
    }

    public function getVrEncargo2Aviso(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getVrenc2aviso();
        }
    }

    public function getVrEncargo2DecTerceiro(){
        if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getVrenc2dec();
        }
    }
    
     public function getNrqtmaxdiasferias() { 
         if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getNrqtmaxdiasferias();
        }
    }
    
    public function getIdpgadiantferias() { 
         if (is_object($this->_paramFolha)) {
            return $this->_paramFolha->historico->getIdpgadiantferias();
        }
    }

    public function procuraParamFolha($nrParamFolha){

        if ($this->_nrParamFolhaAnterior !== $nrParamFolha) {
            $itens = $this->getItems();
            if (count($itens) === 0) {
                $this->_inicializaListaParametroFolha();
                $itens = $this->getItems();
            }
            foreach ($itens as $key=>$item) {
                if ((int)$item->getNrparamfolham() === (int)$nrParamFolha) {
                    $this->_paramFolha = $this->getItem($key);
                    break;
                }
            }
        }
    }

    private function _inicializaListaParametroFolha(){
        try {
            $itens = $this->entityManager->getRepository(Repositories::FPA_PARAMFOLHAM)->retornaParametrosFolha($this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);

            if(count($itens)==0){
                throw new \Exception('Não foi encontrado parâmetro de folha ou o mesmo está incorreto para a estrutura. Confira os parâmetros de estrutura.');
            }

            foreach ($itens as $item) {
                $this->addItem($item);
            }
        } catch(Exception $e) {
            throw $e;
        }

    }
    
    public static function getByNrorg($nrorg) {
        $result = self::getEntityByWhere('NRORG = ?', array($nrorg));
        return $result;
    }

}

