<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class TabelaFolhaRepository {

    protected  $connection;
    
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }
    
    /**
     * Função responsável por duplicar um registro da tabela folha. Ela é usada no contexto
     * de replicar um registro da tabela folha, juntamente com suas faixas
     */
    public function replicarFolha($auditoria, $row){
        $query = $this->entityManager->getConnection()->prepare("
            INSERT INTO FPA_TABELAFOLHA 
                (
                    NRTABELAFOLHA, NMTABELAFOLHA, DTINIVIGENCIA, 
                    DTFIMVIGENCIA, NRORGINCLUSAO, DTINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, 
                    DTULTATU, CDOPERULTATU, NRORG
                ) 
            VALUES
                (
                    :NRTABELAFOLHA, :NMTABELAFOLHA, :DTINIVIGENCIA, 
                    :DTFIMVIGENCIA, :NRORGINCLUSAO, :DTINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, 
                    :DTULTATU, :CDOPERULTATU, :NRORG
                )
        ");
        $query->execute(
            [
                "NRTABELAFOLHA" => $row['newNRTABELAFOLHA'],
                "NMTABELAFOLHA" => $row['newNMTABELAFOLHA'],
                "DTINIVIGENCIA" => $row['newDTINIVIGENCIA'],
                "DTFIMVIGENCIA" => (isset($row['newDTFIMVIGENCIA'])? $row['newDTFIMVIGENCIA'] : ""),
                "NRORGINCLUSAO" => $auditoria['NRORGINCLUSAO'],
                "DTINCLUSAO" => $auditoria['DTINCLUSAO'],
                "CDOPERINCLUSAO" => $auditoria['CDOPERINCLUSAO'],
                "NRORGULTATU" => $auditoria['NRORGINCLUSAO'],
                "DTULTATU" => $auditoria['DTINCLUSAO'],
                "CDOPERULTATU" => $auditoria['CDOPERINCLUSAO'],
                "NRORG" => $auditoria['NRORG']
            ]
        );
        
    }
}