<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class ModeloaprovsoliService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager  = $entityManager;
        $this->hcmParameters  = $hcmParameters;
    }
    
    public function validaOutraFaseMesmaOrdem($row){

        $fases = $this->entityManager->getRepository(Repositories::GPE_FASEAPROVSOLI)->findBy(
            array('nrorg' => $row['NRORG'], 'nrmodeloaprovsoli' => $row['NRMODELOAPROVSOLI'], 'nrordem' => $row['NRORDEM'])
        );

        foreach ($fases as $fase) {
            if ($fase->getNrfaseaprovsoli() != $row['NRFASEAPROVSOLI']) {
                return true;
            }
        }

        return false;
    }
    
    public function validaExclusaoModelo($row){
        
        $objFases = $this->entityManager->getRepository(Repositories::GPE_FASEAPROVSOLI)->findBy(
            array('nrorg' => $row['NRORG'], 'nrmodeloaprovsoli' => $row['NRMODELOAPROVSOLI'])
        );
        if($objFases != null){
            return 'E';
        }
    }
    
}