<?php

namespace HCM\PTO\Logic\AFD\Portaria671;

/**
 * Portaria 671
 * Rodape do arquivo AFD
 * 
 */

use HCM\PTO\Logic\AFD\Rodape as RodapeAFD;

class Rodape extends RodapeAFD {
    /**
     * Portaria 671
     * Responsavel por gerar o conteudo do rodape
     * @return string
     */
    public function geraConteudo(): string {
        return substr(
            /* 001-009 "999999999" */ '999999999' .
            /* 010-018 Quantidade de registros do tipo "2" no arquivo */ str_pad($this->quantidadeRegistrosTipo2(), 9, "0", STR_PAD_LEFT) .
            /* 019-027 Quantidade de registros do tipo "3" no arquivo */ str_pad($this->quantidadeRegistrosTipo3(), 9, "0", STR_PAD_LEFT) .
            /* 028-036 Quantidade de registros do tipo "4" no arquivo */ str_pad($this->quantidadeRegistrosTipo4(), 9, "0", STR_PAD_LEFT) .
            /* 037-045 Quantidade de registros do tipo "5" no arquivo */ str_pad($this->quantidadeRegistrosTipo5(), 9, "0", STR_PAD_LEFT) .
            /* 046-054 Quantidade de registros do tipo "6" no arquivo */ str_pad($this->quantidadeRegistrosTipo6(), 9, "0", STR_PAD_LEFT) .
            /* 055-063 Quantidade de registros do tipo "7" no arquivo */ str_pad($this->quantidadeRegistrosTipo7(), 9, "0", STR_PAD_LEFT) .
            /* 064-064 Tipo do registro. Preencher com "9" */ '9'
        , 0, 64);
    }
    
    /**
     * Portaria 671
     * Responsavel por retornar a quantidade de registros do tipo 2
     * @return int
     */
    public function quantidadeRegistrosTipo2(): int {
        return 0;
    }
    
    /**
     * Portaria 671
     * Responsavel por retornar a quantidade de registros do tipo 3
     * @return int
     */
    public function quantidadeRegistrosTipo3(): string {
        return 0;
    }
    
    /**
     * Portaria 671
     * Responsavel por retornar a quantidade de registros do tipo 4
     * @return int
     */
    public function quantidadeRegistrosTipo4(): int{
        return 0;
    }
    
    /**
     * Portaria 671
     * Responsavel por retornar a quantidade de registros do tipo 5
     * @return int
     */
    public function quantidadeRegistrosTipo5(): int {
        return 0;
    }
    
    /**
     * Portaria 671
     * Responsavel por retornar a quantidade de registros do tipo 6
     * @return int
     */
    public function quantidadeRegistrosTipo6(): int {
        return 0;
    }
    
    /**
     * Portaria 671
     * Responsavel por retornar a quantidade de registros do tipo 7
     * @return int
     */
    public function quantidadeRegistrosTipo7(): int {
        return $this->getContador()->contaRegistrosPorTipo(7);
    }
}