CREATE OR REPLACE
TRIGGER CORRIGE_LOGFASETRAM
BEFORE INSERT ON LOGFASETRAM FOR EACH ROW
DECLARE
   V_CDASSUNTO ASSUNTO.CDASSUNTO%TYPE;
   V_CDPRODGRUP SOLISERV.CDPRODGRUP%TYPE;
   V_CDPRODCOMP SOLISERV.CDPRODCOMP%TYPE;
   V_CDPROJETO PROJETO.CDPROJETO%TYPE;
   V_NRBASELINEPR BASELINEPROJ.NRBASELINEPR%TYPE;
BEGIN
   SELECT CDASSUNTO, CDPRODGRUP, CDPRODCOMP
     INTO V_CDASSUNTO, V_CDPRODGRUP, V_CDPRODCOMP
     FROM SOLISERV
    WHERE CDFILIAL = :NEW.CDFILIAL
      AND NRSOLISERV = :NEW.NRSOLISERV;
   IF (:NEW.TXACAOLFTRAM = 'Abriu a solicitao') THEN
      :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(V_CDPRODCOMP);
      IF V_CDASSUNTO = '00124' THEN
         V_CDASSUNTO := '00013';
      END IF;
      IF V_CDASSUNTO = '00102' THEN
         V_CDASSUNTO := '00010';
      END IF;
      IF (V_CDASSUNTO = '00012') OR /* LEGISLAO - MANUTENO */
         (V_CDASSUNTO = '00013') OR /* EVOLUO TECNOLGICA - MANUTENO */
         (V_CDASSUNTO = '00014') OR /* EVOLUO TECNOLGICA - TEKNISA */
         (V_CDASSUNTO = '00021') OR /* CUSTOMIZAO - ESPECFICO DO CLIENTE */
         (V_CDASSUNTO = '00022') OR /* EVOLUO EM OUTRAS VERSES */
         (V_CDASSUNTO = '00027') OR /* ATUALIZAO DE LEGISLAO */
         (V_CDASSUNTO = '00028') OR /* SIMPLIFICAO DO PRODUTO */
         (V_CDASSUNTO = '00041') THEN /* DESENVOLVIMENTO DE SISTEMA NOVO */
         :NEW.CDFASETRAM := '110'; /* ANLISE DO GERENTE DE PRODUTO */
      END IF;
      IF (V_CDASSUNTO = '00015') THEN /* CORREO DE ERROS EM OUTRAS VERSES */
         :NEW.CDFASETRAM := '265'; /* VERIFICAO DE ERRO */
      END IF;
      IF (V_CDASSUNTO = '00010') OR /* ERRO LEVE - MANUTENO */
         (V_CDASSUNTO = '00011') OR /* ERRO GRAVE - MANUTENO */
         (V_CDASSUNTO = '00016') OR /* PERFORMANCE - MANUTENO */
         (V_CDASSUNTO = '00104') THEN /* PERFORMANCE */
         :NEW.CDOPERRESP := '000000000993'; /* TESTE DE ENTRADA */
         :NEW.CDFASETRAM := '007'; /* TESTE DE ENTRADA */
      END IF;
      IF (V_CDASSUNTO = '02010') THEN /* GERNCIA DE PRODUTO */
         :NEW.CDFASETRAM := '790'; /* GERNCIA DE PRODUTO */
         INSERE_ATIVIDADE(:NEW.CDFILIAL, :NEW.NRSOLISERV, :NEW.CDOPERRESP, V_CDASSUNTO);
      END IF;
   END IF;
   /* APAGA O PROJETO QUANDO RETORNA APROVADA E ENCAMINHA PARA O RESPONSVEL */
   IF (:NEW.CDFASETRAM = '266') OR
      (:NEW.CDFASETRAM = '066') THEN
      :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(V_CDPRODCOMP);
   END IF;
   IF (:NEW.CDFASETRAM = '265') THEN /* VERIFICAO DE ERRO */
      INSERE_ATIVIDADE(:NEW.CDFILIAL, :NEW.NRSOLISERV, :NEW.CDOPERRESP, V_CDASSUNTO);
   END IF;
   IF (:NEW.CDFASETRAM = '080') THEN
      IF (V_CDASSUNTO = '00051') OR /* HOMOLOGAO - TESTE DE USO DO PRODUTO */
         (V_CDASSUNTO = '00061') OR /* HOMOLOGAO - ERRO DE PROCESSO */
         (V_CDASSUNTO = '00062') OR /* HOMOLOGAO - VISITA A CLIENTE */
         (V_CDASSUNTO = '00063') OR /* HOMOLOGAO - ERRO ENCONTRADO PELO DESENVOLVEDOR */
         (V_CDASSUNTO = '00064') THEN /* HOMOLOGAO - ERRO DE TRADUO */
         V_CDPROJETO := PROJETO_POR_SISTEMA(V_CDPRODCOMP, V_CDASSUNTO);
         SELECT MAX(NRBASELINEPR)
           INTO V_NRBASELINEPR
           FROM BASELINEPROJ
          WHERE CDFILIAL = :NEW.CDFILIAL
            AND CDPROJETO = V_CDPROJETO;
         INSERT INTO SOLIBASELINE
            (CDFILIAL, CDPROJETO, NRBASELINEPR, NRSOLISERV, DTINSOLBASELIPR, CDOPINSOLBASELI, IDSITUSOLBASELI)
         VALUES
            (:NEW.CDFILIAL, V_CDPROJETO, '001', :NEW.NRSOLISERV, SYSDATE, :NEW.CDOPERRESP, 'I');
      END IF;
   END IF;
   IF (:NEW.CDFASETRAM = '010') THEN
      :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(V_CDPRODCOMP);
      IF (V_CDASSUNTO = '06000') OR (V_CDPRODGRUP = '0000001386') THEN /* Administrao de rede */
         V_CDASSUNTO := '06000';
         IF (V_CDPRODGRUP <> '0000001386') THEN
            V_CDPRODGRUP := '0000001386';
            V_CDPRODCOMP := '0000001387';
         END IF;
         :NEW.CDFASETRAM := '317';
      END IF;
      IF (V_CDASSUNTO = '05000') OR (V_CDPRODGRUP = '0000001207') THEN /* Comunicao de mercado */
         V_CDASSUNTO := '05000';
         IF (V_CDPRODGRUP <> '0000001207') THEN
            V_CDPRODGRUP := '0000001207';
            V_CDPRODGRUP := '0000001208';
         END IF;
         :NEW.CDFASETRAM := '017';
      END IF;
   END IF;
   /* APAGA O PROJETO QUANDO RETORNA APROVADA E ENCAMINHA PARA O RESPONSVEL */
   IF (:NEW.CDFASETRAM = '266') OR (:NEW.CDFASETRAM = '066') THEN
      DELETE FROM SOLIBASELINE
       WHERE CDFILIAL = :NEW.CDFILIAL
         AND NRSOLISERV = :NEW.NRSOLISERV;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CORRIGE_LOGFASETRAM','5.11.002'); END;
/
